/******************************************************************************
  Ȩ  : 2007-2020Ϊ޹˾
      : atpstuncapi.h
        : handy
        : V1.0
    : 2007-10-26
        : ATPƽ̨STUNЭͻ˶ӿڡЭջֻʵSTUNCBINDING
              ҰSTUNЭʵ˱շ
  б  :

  ʷ¼      :
   1.       : 2007-10-26
            : handy
     ޸   : ɳ

*********************************************************************************/

#ifndef __ATPSTUNCAPI_H__
#define __ATPSTUNCAPI_H__

#ifdef WIN32
#define ATP_STUNC_SOCKET_D      SOCKET
#else
#define ATP_STUNC_SOCKET_D      int
#endif

#define ATP_STUNC_INVALID_SOCKET_D      (-1)

#if 0

#ifndef VOS_OK
#define VOS_OK          (0)
#endif

#ifndef VOS_TRUE
#define VOS_TRUE        (1)
#endif

#ifndef VOS_FALSE
#define VOS_FALSE       (0)
#endif

#ifndef VOS_VOID
#define VOS_VOID        void
#endif

#ifndef VOS_BOOL
#define VOS_BOOL        unsigned int
#endif

#ifndef VOS_UINT32
#define VOS_UINT32      unsigned int
#endif

#ifndef VOS_INT32
#define VOS_INT32       int
#endif

#ifndef VOS_UINT16
#define VOS_UINT16      unsigned short
#endif

#ifndef VOS_INT16
#define VOS_INT16       short
#endif

#ifndef VOS_UINT8
#define VOS_UINT8       unsigned char
#endif

#ifndef VOS_INT8
#define VOS_INT8        char
#endif

#ifndef VOS_CHAR
#define VOS_CHAR        char
#endif

#endif

/* STUNC Transaction IDĳ*/
typedef enum tagATP_STUNC_ERR_CODE_EN
{
    ATP_ERR_STUNC_PARA_NULL         = 1,
    ATP_ERR_STUNC_PARA_INVALID,
    ATP_ERR_STUNC_MEM_NOT_ENOUGH,
    ATP_ERR_STUNC_NOT_INITED,
    ATP_ERR_STUNC_NOT_UNINITED,
    ATP_ERR_STUNC_HMAC,
    ATP_ERR_STUNC_STRING_TOO_LONG,
    ATP_ERR_STUNC_PACKET_TOO_LONG,
    ATP_ERR_STUNC_PACKET_TOO_SHORT,
    ATP_ERR_STUNC_SOCKET,
    ATP_ERR_STUNC_BIND,
    ATP_ERR_STUNC_UNKNOWN_HOST,
    ATP_ERR_STUNC_INVALID_PACKET,
    ATP_ERR_STUNC_INVALID_ATTR,
    ATP_ERR_STUNC_TLS,
    ATP_ERR_STUNC_TIMEOUT,
    ATP_ERR_STUNC_NO_RESPONSE,
    ATP_ERR_STUNC_FORMAT,
    ATP_ERR_STUNC_NONSTUN_DATA
} ATP_STUNC_ERR_CODE_EN;

/* STUNC Transaction IDĳ */
#define ATP_STUNC_TRANSACTIONID_LEN_D           (16)

/* STUNĬ϶˿ */
#define ATP_STUNC_DEFAULT_PORT_NUM_D            (3478)

/* STUNַ󳤶 */
#define ATP_STUNC_STRING_MAX_LEN_D              (256)

/* STUNCĳԴ */
#define ATP_STUNC_MAX_RETRY_NUM_D               (9)

/* STUN Ϣͺ궨 */
#define ATP_STUNC_MSG_BINDING_REQUEST           (0x0001)
#define ATP_STUNC_MSG_BINDING_RESPONSE          (0x0101)
#define ATP_STUNC_MSG_BINDING_ERR_RESPONSE      (0x0111)

        // 汾֧
#define ATP_STUNC_MSG_SECRET_REQUEST            (0x0002)
#define ATP_STUNC_MSG_SECRET_RESPONSE           (0x0102)
#define ATP_STUNC_MSG_SECRET_ERR_RESPONSE       (0x0112)

/* STUN ͺ궨 */
#define ATP_STUNC_ATTR_MAPPED_ADDRESS           (0x0001)
#define ATP_STUNC_ATTR_RESPONSE_ADDRESS         (0x0002)
#define ATP_STUNC_ATTR_CHANGE_ADDRESS           (0x0003)
#define ATP_STUNC_ATTR_SOURCE_ADDRESS           (0x0004)
#define ATP_STUNC_ATTR_CHANGED_ADDRESS          (0x0005)
#define ATP_STUNC_ATTR_USERNAME                 (0x0006)
#define ATP_STUNC_ATTR_PASSWORD                 (0x0007)
#define ATP_STUNC_ATTR_MSG_INTEGRITY            (0x0008)
#define ATP_STUNC_ATTR_ERR_CODE                 (0x0009)
#define ATP_STUNC_ATTR_UNKNOWN_ATTR             (0x000A)
#define ATP_STUNC_ATTR_REFLECTED_FROM           (0x000B)

/*
    STUNC׼бοRFC3489 Section 11.2 Message Attributes
    N/A :   
    O   :   ѡ
    M   :   
    C   :   
                                       Binding  Shared  Shared  Shared
                     Binding  Binding  Error    Secret  Secret  Secret
 Att.                Req.     Resp.    Resp.    Req.    Resp.   Error
                                                                Resp.
 _____________________________________________________________________
 MAPPED-ADDRESS      N/A      M        N/A      N/A     N/A     N/A
 RESPONSE-ADDRESS    O        N/A      N/A      N/A     N/A     N/A
 CHANGE-REQUEST      O        N/A      N/A      N/A     N/A     N/A
 SOURCE-ADDRESS      N/A      M        N/A      N/A     N/A     N/A
 CHANGED-ADDRESS     N/A      M        N/A      N/A     N/A     N/A
 USERNAME            O        N/A      N/A      N/A     M       N/A
 PASSWORD            N/A      N/A      N/A      N/A     M       N/A
 MESSAGE-INTEGRITY   O        O        N/A      N/A     N/A     N/A
 ERROR-CODE          N/A      N/A      M        N/A     N/A     M
 UNKNOWN-ATTRIBUTES  N/A      N/A      C        N/A     N/A     C
 REFLECTED-FROM      N/A      C        N/A      N/A     N/A     N/A
 */

/* TR111չͺ궨 */
#define ATP_TR111_ATTR_CONNECTION_REQUEST       (0xC001)
#define ATP_TR111_ATTR_BINDING_CHANGE           (0xC002)

/*
 * TR111չCONNECTION-REQUEST-BINDINGԵֵ
 * ΪֵַĿո񣬴ճ20ֽڵĳ
 */
#define ATP_TR111_VALUE_CONN_REQUEST            "dslforum.org/TR-111 "

/* CHANGE-REQUESTȡֵ궨 */
#define ATP_STUNC_CHANGE_ADDRESS_IP             (0x04)
#define ATP_STUNC_CHANGE_ADDRESS_PORT           (0x02)

/* STUN 궨 */
#define ATP_STUNC_RESPONSE_BAD_REQUEST          (400)
#define ATP_STUNC_RESPONSE_UNAUTHORIZED         (401)
#define ATP_STUNC_RESPONSE_UNKNOWN_ATTR         (420)
#define ATP_STUNC_RESPONSE_STALE_CREDENTIAL     (430)
#define ATP_STUNC_RESPONSE_INT_CHECK_FAIL       (431)
#define ATP_STUNC_RESPONSE_MISSING_USERNAME     (432)
#define ATP_STUNC_RESPONSE_MISSING_USERNAME     (432)
#define ATP_STUNC_RESPONSE_USE_TLS              (433)
#define ATP_STUNC_RESPONSE_SERVER_ERR           (500)   // Client should retry
#define ATP_STUNC_RESPONSE_GLOBAL_FAILURE       (600)   // Should not retry

/* STUNCԽṹ */
typedef struct tagATP_STUNC_ATTRIBUTE_ST
{
	VOS_UINT16              usAttrType;
	VOS_UINT16              usAttrLen;
	VOS_UINT8               *pucAttrValue;
	struct tagATP_STUNC_ATTRIBUTE_ST    *pstNext;
} ATP_STUNC_ATTRIBUTE_ST;

/* STUNCṹ */
typedef struct tagATP_STUNC_PACKET_ST
{
    VOS_UINT16              usMsgType;
    VOS_UINT16              usMsgLen;
    VOS_UINT8               aucTransactionID[ATP_STUNC_TRANSACTIONID_LEN_D];
    ATP_STUNC_ATTRIBUTE_ST  *pstAttrList;
} ATP_STUNC_PACKET_ST;

/* STUNṹ */
typedef struct tagATP_STUNC_NAT_ENTRY_ST
{
    ATP_STUNC_SOCKET_D  sSocket;        // -1 ʾҪsocket
                                        // ʾʹеsocket

    VOS_UINT32          ulLocalIP;      // IPΪ0Ĭ·ɡ
    VOS_UINT32          ulNatIP;        // NATIP
    VOS_UINT32          ulRemoteIP;	    // IP
    VOS_UINT16          usLocalPort;    // ض˿
    VOS_UINT16          usNatPort;      // NATĶ˿
    VOS_UINT16          usRemotePort;   // ˿
    VOS_UINT16          usResponsePort; // ӦĵԴ˿
    VOS_UINT32          ulResponseIP;   // ӦĵԴIP
    VOS_UINT8           *pucRecvBuf;    // ûҪṩɴṩָ
    VOS_UINT32          ulBufLen;       // ûṩĻ
    VOS_UINT32          ulRecvdDataLen; // յݳ
    VOS_CHAR            *pcUserName;    // ֤ûΪ
    VOS_CHAR            *pcPassword;    // ֤룬Ϊ
#ifdef SUPPORT_ATP_STUNC_TLS
    VOS_UINT32          ulLastTlsTtime;  // һʹTLSʱ䣬ڲʹ
#endif
} ATP_STUNC_NAT_ENTRY_ST;

/* STUNC߻ӦĵĻص */
typedef VOS_UINT32 (*PFAtpStunPacketCb)(
                                ATP_STUNC_SOCKET_D  sSock,
                                ATP_STUNC_PACKET_ST *pstResponse);

/* յSTUNʱĻص */
typedef VOS_UINT32 (*PFAtpNonStunPacketCb)(
                                const VOS_UINT8 *pucPack,
                                VOS_UINT16 usPackLen,
                                ATP_STUNC_NAT_ENTRY_ST *pstNat);
                                

/*****************************************************************************
     : ATP_STUNC_GetVersion
   : 
   : 
   : 
   ֵ  : 汾

 ޸ʷ      :
  1.       : 2009420
           : 42304
    ޸   : ɺ

*****************************************************************************/
const VOS_CHAR * ATP_STUNC_GetVersion(void);

/******************************************************************************
    : ATP_STUNC_ParseAddrMap
    : STUNеMAPPED-ADDRESSֵ
    :
              1. pucAttrValue   :   ֵ
              2. ulAttrLen      :   ֵ
  ú  :
    :
    :
              1. pusPort        :   Ķ˿ںţ
              2. pulIP          :   IPַ
    ֵ  : 

  ޸ʷ      :
   1.       : 2007-10-31
            : handy
     ޸   : ɳ

******************************************************************************/
VOS_UINT32 ATP_STUNC_ParseAddrMap(
                                           const VOS_UINT8      *pucAttrValue,
                                           VOS_UINT16           ulAttrLen,
                                           VOS_UINT16           *pusPort,
                                           VOS_UINT32           *pulIP);

/******************************************************************************
    : ATP_STUNC_AppendAddrMapAttr
    : STUNMAPPED-ADDRESSֵѾڣ򸲸
    :
              1. pstPacket      :   ӵSTUN
              2. usAttrType     :   ӵ
              3. usPort         :   MAPPED-ADDRESSĶ˿ֵ
              4. ulIP           :   MAPPED-ADDRESSIPֵַ
  ú  :
    :
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2007-10-31
            : handy
     ޸   : ɳ

******************************************************************************/
VOS_UINT32 ATP_STUNC_AppendAddrMapAttr(
                                           ATP_STUNC_PACKET_ST  *pstPacket,
                                           VOS_UINT16           usAttrType,
                                           VOS_UINT16           usPort,
                                           VOS_UINT32           ulIP);

/******************************************************************************
    : ATP_STUNC_AppendStrAttr
    : STUNֵַSTUNЭҪֵ4ֽڶ룬
              ˣṩ˽ӿڱַ֤ʱ
              Ѿڣ򸲸
    :
              1. pstPacket      :   ӵSTUN
              2. usAttrType     :   ӵ
              3. pcAttrStr      :   ӵֵַ
  ú  :
    :
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2007-10-31
            : handy
     ޸   : ɳ

******************************************************************************/
VOS_UINT32 ATP_STUNC_AppendStrAttr(ATP_STUNC_PACKET_ST          *pstPacket,
                                           VOS_UINT16           usAttrType,
                                           const VOS_CHAR       *pcAttrStr);

/******************************************************************************
    : ATP_STUNC_AppendAttr
    : STUNһSTUNԣѾڣ򸲸
    :
              1. pstPacket      :   STUNָ
              2. usAttrType     :   
              3. usAttrLen      :   ֵ
              4. pucAttrValue   :   ֵΪݣ뱣֤Ϊ·
  ú  :
    :
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2007-10-26
            : handy
     ޸   : ɳ

******************************************************************************/
VOS_UINT32 ATP_STUNC_AppendAttr(ATP_STUNC_PACKET_ST *pstPacket,
                                        VOS_UINT16          usAttrType,
                                        VOS_UINT16          usAttrLen,
                                        const VOS_UINT8     *pucAttrValue);

/******************************************************************************
    : ATP_STUNC_GetAttribute
    : ȡSTUNָ
    :
              1. pstPacket  :   STUNָ
              2. usAttrType :   ȡ
  ú  :
    :
    : 
    ֵ  :
              ҵ򷵻ظԽṹָ
              ûҵ򷵻NULL

  ޸ʷ      :
   1.       : 2007-10-31
            : handy
     ޸   : ɳ

******************************************************************************/
const ATP_STUNC_ATTRIBUTE_ST *ATP_STUNC_GetAttribute(
                                const ATP_STUNC_PACKET_ST     *pstPacket,
                                VOS_UINT16                    usAttrType);

/******************************************************************************
    : ATP_STUNC_GenerateTransactionID
    : ΪSTUNTransactionID
    :
              1. pstPacket  :   TransactionIDSTUN
  ú  :
    :
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2007-10-31
            : handy
     ޸   : ɳ

******************************************************************************/
VOS_UINT32 ATP_STUNC_GenerateTransactionID(
                                ATP_STUNC_PACKET_ST            *pstPacket);

/******************************************************************************
    : ATP_STUNC_DestroyPacketAttrs
    : STUNе
    :
              1. pstPacket  :   STUNָ
  ú  :
    :
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2007-10-31
            : handy
     ޸   : ɳ

******************************************************************************/
VOS_UINT32 ATP_STUNC_DestroyPacketAttrs(
                                    ATP_STUNC_PACKET_ST        *pstPacket);

/******************************************************************************
    : ATP_STUNC_SendPacket
    : ѾõSTUNյӦӦ
              ҰѽŵӦ
    :
              1. sSecondSocket  :   SocketΪ-1
                                    ʾʹøSocketͱģ
                                    ʹpstNatеSocketͱ
              2. pstNat         :   NATṹ
              3. pstPacket      :   ͵STUN
              4. pstResponse    :   յĻӦ
  ú  :
    :
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2007-10-31
            : handy
     ޸   : ɳ

******************************************************************************/
VOS_UINT32 ATP_STUNC_SendPacket(
                    ATP_STUNC_SOCKET_D                 sSecondSocket,
                    ATP_STUNC_NAT_ENTRY_ST             *pstNat,
                    ATP_STUNC_PACKET_ST                *pstPacket,
                    ATP_STUNC_PACKET_ST                *pstResponse);

/******************************************************************************
    : ATP_STUNC_Init
    : ʼSTUNCģıIPͶ˿
    :
              1. usRetryTimes : ԴΪ[1-9]
                                ֵʹĬֵ9
              2. pcUsername   : STUNC֤û
                                ΪգͨTLSȡ֤Ϣ
                                ֻʹֵ
              3. pcPassword   : STUNC֤룬ͬ
  ú  :
    :
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2007-10-27
            : handy
     ޸   : ɳ
   2.       : 2008-3-12
            : handy
     ޸   : V100R002C02

******************************************************************************/
VOS_UINT32 ATP_STUNC_Init(
                                VOS_UINT16          usRetryTimes,
                                const VOS_CHAR      *pcUsername,
                                const VOS_CHAR      *pcPassword);

/******************************************************************************
    : ATP_STUNC_UnInit
    : ȥʼSTUNCģ
    : 
  ú  :
    :
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2007-10-26
            : handy
     ޸   : ɳ
   2.       : 2008-3-12
            : handy
     ޸   : V100R002C02

******************************************************************************/
VOS_UINT32 ATP_STUNC_UnInit(VOS_VOID);

/******************************************************************************
    : ATP_STUNC_GetNatIPPort
    : ȡNATתIPͶ˿
    :
              1. pstNat     :   NATṹ
  ú  :
    :
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2007-10-27
            : handy
     ޸   : ɳ
   2.       : 2008-3-12
            : handy
     ޸   : V100R002C02

******************************************************************************/
VOS_UINT32 ATP_STUNC_GetNatIPPort(
                            ATP_STUNC_NAT_ENTRY_ST  *pstNat);

/******************************************************************************
    : ATP_STUNC_GetMultiNatIPPort
    : ȡNATÿNATԼsocket
    :
              1. pstNat[]   :   ѯNATָ
              2. ulNum      :   ѯNAT
  ú  :
    :
    :
              1. pulIdx     :   ȡݵNAT
    ֵ  : 

  ޸ʷ      :
   1.       : 2008-5-16
            : handy
     ޸   : ɳ

******************************************************************************/
VOS_UINT32 ATP_STUNC_GetMultiNatIPPort(
                            ATP_STUNC_NAT_ENTRY_ST  *pstNat[],
                            VOS_UINT32              ulNum,
                            VOS_INT32               lSendIdx,
                            VOS_UINT32              *pulIdx);


/******************************************************************************
    : ATP_STUNC_IsNatTimeout
    : жNATǷѾʱ
    :
              1. pstNat     :   NATṹ
              2. pbTimeout  :   ǷʱVOS_TRUE: ǣVOS_FALSE: 
  ú  :
    :
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2007-10-27
            : handy
     ޸   : ɳ
   2.       : 2008-3-12
            : handy
     ޸   : V100R002C02

******************************************************************************/
VOS_UINT32 ATP_STUNC_IsNatTimeout(
                            ATP_STUNC_NAT_ENTRY_ST  *pstNat,
                            VOS_BOOL                *pbTimeout);

/******************************************************************************
    : ATP_STUNC_IsNatSymmetric
    : жNAT豸ǷΪԳNATSTUNЭ鲻ԽԳNAT豸
    :
              1. pstNat     :   NATṹ
              2. pbSymmetric:   ǷΪԳNAT豸VOS_TRUE: ǣVOS_FALSE: 
  ú  :
    :
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2007-10-27
            : handy
     ޸   : ɳ
   2.       : 2008-3-12
            : handy
     ޸   : V100R002C02

******************************************************************************/
VOS_UINT32 ATP_STUNC_IsNatSymmetric(
                            ATP_STUNC_NAT_ENTRY_ST  *pstNat,
                            VOS_BOOL                *pbSymmetric);

/******************************************************************************
    : ATP_STUNC_Start
    : STUNCģ飬ִNAT󣬸ú˳ʱ
              ԶѧϰNAT豸ˢڣˢNAT
    :
              1. sSocket        :   socketΪ-1ʾѾ
                                    socket򱾺дsocket
              2. ulLocalIP      :   صIPʽIP
              3. usLocalPort    :   صĶ˿
              4. lMaxPeriod     :   STUNCˢµڣΪ-1ʾû
              5. ulMinPeriod    :   STUNCˢµС
  ú  :
    :
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2007-10-26
            : handy
     ޸   : ɳ
   2.       : 2008-3-12
            : handy
     ޸   : V100R002C02

******************************************************************************/
VOS_UINT32 ATP_STUNC_Start(
                                ATP_STUNC_SOCKET_D  sSocket,
                                VOS_UINT32          ulLocalIP,
                                VOS_UINT16          usLocalPort,
                                VOS_UINT32          ulRemoteIP,
                                VOS_UINT16          usRemotePort,
                                VOS_INT32           lMaxPeriod,
                                VOS_UINT32          ulMinPeriod);

/******************************************************************************
    : ATP_STUNC_RegPacketHooks
    : עSTUNĻص
    :
              1. pfNonStunCb    :   STUNĵĴ
              2. pfReqCb        :   STUNĻص
              3. pfResCb        :   STUNӦĻص
  ú  :
    :
    : 
    ֵ  : VOS_OK

  ޸ʷ      :
   1.       : 2007-10-26
            : handy
     ޸   : ɳ

******************************************************************************/
VOS_UINT32 ATP_STUNC_RegPacketHooks(
                                        PFAtpNonStunPacketCb    pfNonStunCb,
                                        PFAtpStunPacketCb       pfReqCb,
                                        PFAtpStunPacketCb       pfResCb);

#ifdef SUPPORT_ATP_STUNC_TLS
/******************************************************************************
    : ATP_STUNC_RegRootCertPath
    : עTLSȡû֤ĸ֤·ֻ֧TLSʱʹ
    :
              1. pcPath :   ֤·
  ú  :
    :
    : 
    ֵ  : 

  ޸ʷ      :
   1.       : 2008-4-15
            : handy
     ޸   : ɳ

******************************************************************************/
VOS_UINT32  ATP_STUNC_RegRootCertPath(const VOS_CHAR *pcPath);
#endif

#endif

